MODULE Grund;

IMPORT B:=Spielbrett, X:=ColorPlane, St:=Strings, F:=Float, Sch:=SchalterInit;

(* Thomas *)

PROCEDURE LoescheTBuffer;
VAR d   : CHAR;
BEGIN
 WHILE X.KeyPressed() DO
   d:= X.ReadKey()
 END
END LoescheTBuffer;


PROCEDURE TextLoeschen*;
VAR     i : INTEGER;
BEGIN
  X.GotoXY(20,Sch.yText-20);
  FOR i := 1 TO 60 DO
    X.WriteStr (" ");
  END;
END TextLoeschen;

PROCEDURE Eingeben*(VAR z: LONGINT;i:INTEGER);
VAR         h   : ARRAY 11 OF CHAR;
            r   : CHAR;
BEGIN
    LoescheTBuffer;
    TextLoeschen;
    X.GotoXY   (20,Sch.yText-20);
    St.Str     (i,h);
    St.Append  (h,". Feld, ");
    X.WriteStr (h);  
    X.WriteStr ("Zahl eingeben :  ");
    X.ReadStr  (h,7,r);
    z := St.Val(h);
END Eingeben;

PROCEDURE Ausgeben*(z : LONGINT;i:INTEGER);
VAR    h   : ARRAY 13 OF CHAR;
       p   : LONGINT;
BEGIN
      IF i=1 THEN
         X.GotoXY (20,Sch.yText-20);
         X.WriteStr ("Ergebnis : ");
      ELSE 
         X.WriteStr ("     Rest  : ");
      END;   
      F.StrF(z,10,0,h);
      p := St.Pos (".",h,1);
      St.Delete(h,p,1);
      X.WriteStr (h);
END Ausgeben;

PROCEDURE TextAusgeben* (t:ARRAY OF CHAR);
BEGIN
  TextLoeschen;
  X.GotoXY (20,Sch.yText-20);
  X.WriteStr ("Stein ");
  X.WriteStr (t);
  X.WriteStr (" auswhlen");
END TextAusgeben;
(* Thomas *)

PROCEDURE Wert*(zeile: INTEGER): LONGINT;
VAR wert: LONGINT;
BEGIN
    CASE zeile OF
     10: wert := 100000
    | 9: wert := 50000
    | 8: wert := 10000
    | 7: wert := 5000
    | 6: wert := 1000
    | 5: wert := 500
    | 4: wert := 100
    | 3: wert := 50
    | 2: wert := 10
    | 1: wert := 5
    | 0: wert := 1
    ELSE HALT(101)
    END;
    RETURN wert
END Wert;

PROCEDURE Zeile*(wert: LONGINT): INTEGER;
VAR zeile: INTEGER;
BEGIN
    zeile := -1;
    IF wert = 1 THEN zeile := 0 END;
    IF wert = 5 THEN zeile := 1 END;
    IF wert = 10 THEN zeile := 2 END;
    IF wert = 50 THEN zeile := 3 END;
    IF wert = 100 THEN zeile := 4 END;
    IF wert = 500 THEN zeile := 5 END;
    IF wert = 1000 THEN zeile := 6 END;
    IF wert = 5000 THEN zeile := 7 END;
    IF wert = 10000 THEN zeile := 8 END;
    IF wert = 50000 THEN zeile := 9 END;
    IF wert = 100000 THEN zeile := 10 END;
    IF zeile = -1 THEN HALT(102) END;
    RETURN zeile
END Zeile;

PROCEDURE Numeration*(feld: INTEGER;  zahl: LONGINT; mo: INTEGER);

VAR i: INTEGER;

    PROCEDURE Belegen(zeile: INTEGER;  wert: LONGINT);
    BEGIN
        B.brett[feld, zeile].gesamt := SHORT(zahl DIV wert);
        zahl := zahl MOD wert
    END Belegen;    

BEGIN
    IF feld = 0 THEN
        B.AllesLoeschen(mo);  
    END;
    FOR i := 10 TO 0 BY -1 DO Belegen(i, Wert(i)) END;
    B.AllesZeichnen(FALSE,mo)
END Numeration;

PROCEDURE Elevieren1*(feld,mo: INTEGER);
VAR zeile, anzahl, ganz, rest: INTEGER;
BEGIN 
    FOR zeile := 0 TO 9 DO
        IF ODD(zeile) THEN 
          anzahl := 2
        ELSE 
          anzahl := 5
        END;
        ganz := B.brett[feld, zeile].gesamt DIV anzahl;
        rest := B.brett[feld, zeile].gesamt MOD anzahl;
        B.brett[feld, zeile+1].gesamt := B.brett[feld, zeile+1].gesamt + ganz;
        B.brett[feld, zeile].gesamt := rest
    END; 
    B.AllesZeichnen(FALSE,mo)  
END Elevieren1;
        
PROCEDURE Elevieren2*(feld: INTEGER;  wert: LONGINT; mo: INTEGER);
VAR zeile, anzahl, differenz: INTEGER;

BEGIN
    IF ~B.Leer(feld) THEN
        zeile := Zeile(wert);
        IF ODD(zeile) THEN 
          anzahl := 2
          ELSE 
          anzahl := 5
        END;
        IF (B.brett[feld, zeile].gesamt>=anzahl) THEN
            differenz := B.brett[feld, zeile].gesamt - anzahl;
            B.brett[feld, zeile].hohl := anzahl;
            B.AllesZeichnen(TRUE,mo);
            B.brett[feld, zeile].hohl := 0;
            B.brett[feld, zeile].gesamt := differenz;
            B.brett[feld, zeile+1].gesamt := B.brett[feld, zeile+1].gesamt + 1;
            B.brett[feld, zeile+1].hohl := 1;
            B.AllesZeichnen(TRUE,mo);
            B.brett[feld, zeile+1].hohl := 0;
            B.AllesZeichnen(FALSE,mo);
        END 
    END;
END Elevieren2;

PROCEDURE Resolvieren*(feld: INTEGER;  wert: LONGINT; mo: INTEGER);
VAR zeile, anzahl: INTEGER;
BEGIN
    zeile := Zeile(wert);
    IF ODD(zeile)
    THEN anzahl := 5
    ELSE anzahl := 2
    END;
    IF B.brett[feld, zeile].gesamt >= 1 THEN
        B.brett[feld, zeile].hohl := 1;
        B.AllesZeichnen(TRUE,mo);
        B.brett[feld, zeile].hohl := 0;
        DEC(B.brett[feld, zeile].gesamt);
        B.brett[feld, zeile-1].gesamt := B.brett[feld, zeile-1].gesamt + anzahl;
        B.brett[feld, zeile-1].hohl := anzahl;
        B.AllesZeichnen(TRUE,mo);
        B.brett[feld, zeile-1].hohl := 0;
        B.AllesZeichnen(FALSE,mo)
    END
END Resolvieren;

PROCEDURE ResultatErmitteln*(i:INTEGER): LONGINT;
VAR     zeile: INTEGER;
        resultat: LONGINT;
BEGIN
    resultat := 0;
    FOR zeile := 0 TO 10 DO
        resultat := resultat + Wert(zeile) * B.brett[i, zeile].gesamt
    END;
    RETURN resultat
END ResultatErmitteln;
END Grund.
