MODULE SchalterInit;
IMPORT Buttons,X:=ColorPlane;
(*Bei 1024x768 sy=600, bei 800x600 sy=500 setzen!*) 
CONST   sy*  = 500;  sx* = 600;         (* Konstanten fr Schalter   *)
        bs   = 100;  hs  = sy DIV 20;   (* Werden von oben beginnend *)
        abss = (9*hs) DIV 5;  (*4/5*)                 (* gezeichnet                *)

(*Konstanten fr Ausgabe von Linien und Text in Maus.mod,Grund.mod *)
(*und Spielbrett.mod verwendet*)
       yStrich*    = sy DIV 5;        (* Position des tiefsten Striches...*)
       abstStrich* = yStrich DIV 3;   (* Strichabstand                    *)
       yText*      = sy+20;           (* Hchster Textpunkt               *) 
                                 
       AnzSch* = 17;                           

TYPE   SchalterfeldT*  = ARRAY AnzSch OF Buttons.SchalterT;                                   

PROCEDURE HgrZeichnen*;
BEGIN;    
    X.SetBackColor(240,240,160);
    X.Clear;
    X.Bar(0,-68,1024,700,0);
END HgrZeichnen;    

PROCEDURE Init* (VAR Schalter: SchalterfeldT);
VAR       x,y,abst : INTEGER;
          S,T      : Buttons.FarbT;
BEGIN
    x := sx; y := sy;abst:=abss;
    Schalter[0].Init(x,y,bs,hs);          (* Reihe 1 *)
    Schalter[0].Text("Zahl 1");
    y := y-abst;
    Schalter[1].Init(x,y,bs,hs);          (* 2 *)
    Schalter[1].Text("Zahl 2");
    y := y-abst;
    Schalter[2].Init(x,y,bs,hs);          (* 3 *)
    Schalter[2].Text("Hherlegen");
    y := y-abst;
    Schalter[3].Init(x,y,bs,hs);          (* 4 *)
    Schalter[3].Text("Hher");
    y := y-abst;
    Schalter[4].Init(x,y,bs,hs);          (* 5 *)
    Schalter[4].Text("Ausgeben");
    y := y-abst;
    Schalter[5].Init(x,y,bs,hs);          (* 6 *)
    Schalter[5].Text("Addieren"); 
    
    Schalter[6].Init(x,y,bs,hs); 
    Schalter[6].Text("M --> R");
    
    Schalter[7].Init(x,y,bs,hs); 
    Schalter[7].Text("Subtrahieren"); 
    
    Schalter[8].Init(x,y,bs,hs); 
    Schalter[8].Text("Wegnehmen"); 
                                          (* 7 *)
    y := y-abst;
    Schalter[9].Init(x,y,bs,hs); 
    Schalter[9].Text("Tiefer"); 
                                          (* 8 *)
    y := y-abst;
    Schalter[10].Init(x,y,bs,hs); 
    Schalter[10].Text("Lschen"); 
    
    Schalter[11].Init(x,y,bs,hs); 
    Schalter[11].Text("Wegnehmen");
                                          (* 9 *)
    y := y-abst;
    Schalter[12].Init(x,y,bs,hs); 
    Schalter[12].Text("L --> R");
                                          (* 10 *)
    y := y-abst;
    Schalter[13].Init(x,y,bs,hs); 
    Schalter[13].Text("Schluss");

    y := y-abst;
    Schalter[14].Init(x,y,bs,hs); 
    Schalter[14].Text("Nochmal");
    
    x := x-bs-abst;
    Schalter[15].Init(x,y,bs,hs);
    Schalter[15].Text("Schneller");
    
    x := x-bs-abst;
    Schalter[16].Init(x,y,bs,hs);
    Schalter[16].Text("Langsamer");
 
(* Farben *)
    S.r:=240;S.g:=80;S.b:=70;
    T.r:= 0;T.g:=0;T.b:=0;
    FOR x := 0 TO 16 DO
      Schalter[x].Faerben(S,T);
    END;
END Init;
END SchalterInit.
