MODULE Buttons;
IMPORT C:= ColorPlane, St:=Strings,W:=Windows;
TYPE   FarbT*      = RECORD
          r*,g*,b* : INTEGER;
       END;   
       TextT*      = ARRAY 15 OF CHAR;
       MausfeldT*  = RECORD
          x,y,l,h  : INTEGER;
       END;
       MausfeldP*  = POINTER TO MausfeldT;   
       SchalterT*  = RECORD (MausfeldT)
          t        : TextT;
          S,T      : FarbT;       (* Schalter, Text *)
       END;
       SchalterP*  = POINTER TO SchalterT;

PROCEDURE Warte*(d:LONGINT);
VAR  s, e: LONGINT;
BEGIN
  s := W.GetTickCount();
  REPEAT
    e := W.GetTickCount();
  UNTIL ABS(e - s) > d;
END Warte;


PROCEDURE (VAR s:MausfeldT) Init* (x,y,l,h:INTEGER);
BEGIN
  s.x:=x; s.y:=y; s.l:=l; s.h:=h;
END Init;

(* PROCEDURE (VAR s:MausfeldT) Befehl* (p:PROCEDURE);
BEGIN
  p;
END Befehl; *)

(* Absolut hol, auf diese Weise eine Prozedur zu starten :(((( *)

PROCEDURE (VAR s:MausfeldT) Ueberrollt* ():BOOLEAN;
CONST   l = 0; r = 2;
VAR     Tasten   : SET;
        xm,ym    : INTEGER;
BEGIN
  C.GetMouse(Tasten,xm,ym); 
  RETURN (xm>s.x)&(xm<(s.x+s.l))&(ym<s.y)&(ym>(s.y-s.h));
END Ueberrollt;

PROCEDURE (VAR s:MausfeldT) Getroffen* ():BOOLEAN;
CONST   l = 0; r = 2;
VAR     Tasten   : SET;
        xm,ym    : INTEGER;
BEGIN
  C.GetMouse(Tasten,xm,ym);
  RETURN (s.Ueberrollt())&(l IN Tasten);
END Getroffen;

PROCEDURE RechtsKlick* ():BOOLEAN;
CONST   l = 0; r = 2;
VAR     Tasten   : SET;
        xm,ym    : INTEGER;
BEGIN
  C.GetMouse(Tasten,xm,ym);
  RETURN (r IN Tasten);
END RechtsKlick;

PROCEDURE (VAR s:SchalterT) Text* (t:TextT);
BEGIN
  s.t := t;
END Text;

PROCEDURE (VAR s:SchalterT) Faerben* (S,T:FarbT);
VAR
BEGIN
    s.S.r := S.r; s.S.g := S.g; s.S.b := S.b;
    s.T.r := T.r; s.T.g := T.g; s.T.b := T.b;
END Faerben;

PROCEDURE (VAR s:SchalterT) Zeichnen*;
VAR    rText,r,g,b,rv,gv,bv : INTEGER;
BEGIN
  C.GetForeColor (rv,gv,bv);
  C.GetBackColor (r,g,b);
  C.SetForeColor (s.S.r,s.S.g,s.S.b); 
  C.Bar(s.x,s.y,s.x+s.l,s.y-s.h,1);
  rText := SHORT(s.l DIV 2 - St.Length(s.t)*4);
  C.GotoXY(s.x+rText,s.y-(s.h-10) DIV 2);
  C.SetForeColor (s.T.r,s.T.g,s.T.b);
  C.SetBackColor (s.S.r,s.S.g,s.S.b);
  C.WriteStr(s.t);
  C.SetBackColor (r,g,b);
  C.Box (s.x,s.y,s.x+s.l,s.y-s.h,1);
  C.SetForeColor (rv,gv,bv);
END Zeichnen;
BEGIN
END Buttons.
